<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getClient } from '~/plugins/contentful.js';
import { CONTENT_TYPES } from '~/common/content-types';
import {
  CTA as CallToAction,
  Copy,
  CopyMedia,
  CopyResources,
  FeaturedMedia,
  NextStepAlt,
  SlpBreadcrumb,
  Table as SlpTable,
} from '../../../components/common/index.vue';
import {
  CompanyCopyCard as CopyCard,
  CopyMediaCard,
} from '../../../components/company/index.vue';
import {
  BenefitsIcons,
  TopicsCards,
  TopicsCopyBlock,
  TopicsCta,
  TopicsEmphasis,
  TopicsHeader,
  TopicsInfoTable,
} from '../../../components/topics/index.vue';
import { SolutionsResourceCards } from '~/components/solutions/index.vue';
import { getPageMetadata } from '~/common/meta';
import { handleTopicFromContentful } from '~/services/topics.service';
import {
  convertToCaseSensitiveLocale,
  getAvailableLanguagesFromTags,
} from '~/common/util';
import { AvailableLanguagesMixin } from '~/mixins';

export default Vue.extend({
  components: {
    CallToAction,
    Copy,
    CopyResources,
    CopyCard,
    CopyMediaCard,
    CopyMedia,
    TopicsCards,
    TopicsCta,
    BenefitsIcons,
    TopicsHeader,
    FeaturedMedia,
    SlpTable,
    SlpBreadcrumb,
    TopicsCopyBlock,
    SolutionsResourceCards,
    TopicsInfoTable,
    TopicsEmphasis,
    NextStepAlt,
  },
  mixins: [AvailableLanguagesMixin],
  async middleware(context) {
    if (process.client) {
      return;
    }

    const locale = convertToCaseSensitiveLocale(context.i18n.locale);
    const slug = Object.values(context.params).join('/');
    const completeSlug = `/topics/${slug}/`.replaceAll('//', '/');

    const { items } = await getClient().getEntries({
      content_type: CONTENT_TYPES.TOPICS,
      'fields.slug': completeSlug,
      include: 3,
      locale,
    });

    const [page] = items;

    context.$pageData = page;
    if (page) {
      context.$availableLanguages = getAvailableLanguagesFromTags(
        page.metadata.tags,
      );
    }
  },
  async asyncData({ params, i18n, $pageData, $availableLanguages }: any) {
    try {
      const childTopic = handleTopicFromContentful($pageData.fields);

      if (!childTopic) {
        throw new Error(
          `Error parsing Contentful data on /topics/devops/${
            params.slug ? params.slug : ''
          }`,
        );
      }

      if (childTopic.sideMenu.anchors) {
        childTopic.sideMenu.anchors.text = i18n.t('sideNavigation');
      }

      return { childTopic, availableLanguages: $availableLanguages };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).childTopic,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
      this.availableLanguages,
    );
  },
});
</script>

<template>
  <div>
    <SlpContainer>
      <div v-if="childTopic.sideMenu">
        <SlpBreadcrumb class="slp-mt-32" :crumbs="childTopic.crumbs" />
        <TopicsHeader
          v-if="childTopic.topicsHeader"
          :data="childTopic.topicsHeader.data"
        />
        <SlpSideNavigation
          :data="childTopic.sideMenu"
          :class="{
            'side-navigation--w-hero': childTopic.topicsHeader,
            'side-navigation--w-old-hero': childTopic.old_topicsHeader,
          }"
        >
          <template v-if="childTopic.sideMenu.hyperlinks" #footer>
            <div>
              <SlpTypography
                v-show="childTopic.sideMenu.hyperlinks.text"
                tag="div"
                variant="body3-bold"
                class="nav-heading"
                >{{ childTopic.sideMenu.hyperlinks.text }}</SlpTypography
              >
              <SlpButton
                v-for="(button, buttonIndex) in childTopic.sideMenu.hyperlinks
                  .data"
                :key="buttonIndex"
                class="hyperlinks"
                :variant="button.variant"
                :href="button.href"
                :data-ga-name="button.data_ga_name"
                :data-ga-location="button.data_ga_location"
                >{{ button.text }}
                <SlpIcon
                  v-if="button.icon"
                  class="slp-ml-8"
                  name="chevron-lg-right"
                  variant="product"
                  alt="Chevron Right Icon"
                />
              </SlpButton>
            </div>
          </template>
          <component
            :is="component.name"
            v-for="(component, index) in childTopic.sideMenu.content"
            :key="component.name + `-${index}`"
            :data="component.data"
          />
        </SlpSideNavigation>
      </div>
      <component
        :is="component.name"
        v-for="(component, i) in childTopic.components"
        :key="i"
        :data="component.data"
      />
    </SlpContainer>
    <NextStepAlt />
  </div>
</template>
<style lang="scss" scoped>
:deep .dropdown {
  margin: $spacing-32 0;
}
:deep #collapsible-sidebar {
  overflow-y: scroll;
  max-height: calc(100vh - $spacing-96);
  height: 100%;
}
.side-navigation--w-old-hero {
  :deep #collapsible-sidebar {
    padding-top: 0 !important;
  }
}
.side-navigation--w-hero {
  :deep #collapsible-sidebar {
    margin-top: $spacing-96;
  }
}
.hyperlinks {
  font-size: $font-size-default;
  line-height: 20px;
  font-weight: $font-weight-normal;
  text-align: left !important;
}
.nav-heading {
  margin-bottom: $spacing-8;
}
</style>
